# include <stdio.h>
# include <stdlib.h>
#define SIZE 8
//# define false 0
//# define true 1
/*SCOPO: definizione di alcune 
funzioni ricorsive  per manipolare array di interi*/
typedef enum{false, true} Boolean;
struct elemento{int info; struct elemento *next;};
typedef struct elemento ElementoLista;
typedef ElementoLista *ListaDiElementi;

/*Inserzione in testa alla lista*/
ListaDiElementi inTesta(ListaDiElementi L, int v);

/*Lettura ricorsiva di una lista usa inTesta modifica il parametro*/
void readListIntRic (ListaDiElementi *L, int K) ;

/*Lettura iterativa di una lista usa inTesta modifica il parametro*/
void readListIntIt (ListaDiElementi *L, int K) ;

/*Lettura ricorsiva di una lista usa inTesta calcola la lista come risultato*/
ListaDiElementi readListIntRicFun (ListaDiElementi L,int K );

/*Lettura ricorsiva di una lista usa InserisciTestalista modifica il parametro*/
void readListIntRicTesta (ListaDiElementi *L, int K );

/*Stampa ricorsiva di una lista di interi */
void writeListIntRic (ListaDiElementi L );

/*Stampa iterativa di una lista di interi */
void writeListIntIt (ListaDiElementi L );

/*Copia di una lista L, la funzione restituisce la copia come risultato*/
ListaDiElementi copiaRic(ListaDiElementi L);
ListaDiElementi copiaIt(ListaDiElementi L);
void CancellaPrimo(ListaDiElementi *L);
ListaDiElementi CancellaPrimoL(ListaDiElementi L);
/*Ricerca (ricorsiva) un elemento in una lista NON ordinata, restituisce la posizione in p */
Boolean ricercaListaIntRic (ListaDiElementi L,int x, int *p) ;
/*Ricerca (iterativa) un elemento in una lista NON ordinata, restituisce la posizione in p */
Boolean ricercaListaIntIt (ListaDiElementi L,int x, int *p) ;
/*Calcolo del massimo in una lista di interi */
int minListaIntRic (ListaDiElementi L);
int minListaIntIt (ListaDiElementi L);
/*Inserzione in coda*/
void inCoda(ListaDiElementi *lista, int elem);
ListaDiElementi inCodaC (ListaDiElementi lista, int elem);
ListaDiElementi inOrd(ListaDiElementi lista, int elem);

void CancellaElementoLista(ListaDiElementi *lista, int elem);
ListaDiElementi append (ListaDiElementi L1, ListaDiElementi L2);
ListaDiElementi reverse(ListaDiElementi lista);
ListaDiElementi mergeRic(ListaDiElementi L1, ListaDiElementi L2);
ListaDiElementi mergeIt(ListaDiElementi L1, ListaDiElementi L2);